import { Component, ViewChild } from '@angular/core';
import { RouterOutlet } from '@angular/router';
import { ComplexHierarchicalTree, ConnectorModel, Container, IExportOptions,DataBinding, Diagram, DiagramAllModule, DiagramComponent, DiagramTools, ImageElement, LayoutModel, NodeModel, SnapConstraints, SnapSettingsModel, StackPanel, TextElement, NodeConstraints, ConnectorConstraints, ConnectionPointOrigin, LineDistribution } from '@syncfusion/ej2-angular-diagrams';
import { DataManager } from '@syncfusion/ej2-data';
Diagram.Inject(DataBinding, ComplexHierarchicalTree, LineDistribution);

export interface DataInfo {
  [key: string]: string;
}


@Component({
  selector: 'app-root',
  standalone: true,
  imports: [DiagramAllModule],
  templateUrl: './app.component.html',
  styleUrl: './app.component.scss'
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram: DiagramComponent| any;
  public Data: any = [
    {
      title: 'Node 114',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node114',
      ReportingPerson: ['node11', 'node21', 'node31'],
      isRoot: false,
      fillColor: '#f3904a',
      border: '#d3722e',
    },
    {
      title: 'Node 1',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node1',
      isRoot: true,
      fillColor: '#e7704c',
      border: '#c15433',
    },
    {
      title: 'Node 11',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node11',
      ReportingPerson: ['node1'],
      isRoot: false,
      fillColor: '#e7704c',
      border: '#c15433',
    },
    {
      title: 'Node 12',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node12',
      ReportingPerson: ['node114'],
      isRoot: false,
      fillColor: '#efd46e',
      border: '#d6b123',
    },
    {
      title: 'Node 13',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node13',
      ReportingPerson: ['node12'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 14',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node14',
      ReportingPerson: ['node12'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 15',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node15',
      ReportingPerson: ['node12'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 16',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node16',
      ReportingPerson: [],
      isRoot: false,
      fillColor: '#14ad85',
    },
    {
      title: 'Node 17',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node17',
      ReportingPerson: ['node13', 'node14', 'node15'],
      isRoot: false,
      fillColor: '#659be5',
      border: '#3a6eb5',
    },
    {
      title: 'Node 18',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node18',
      ReportingPerson: [],
      isRoot: false,
      fillColor: '#14ad85',
    },
    {
      title: 'Node 19',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node19',
      ReportingPerson: ['node16', 'node17', 'node18'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    {
      title: 'Node 116',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node116',
      ReportingPerson: ['node22', 'node12'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 110',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node110',
      ReportingPerson: ['node16', 'node17', 'node18'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    {
      title: 'Node 111',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node111',
      ReportingPerson: ['node16', 'node17', 'node18', 'node116'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    // {
    //   title: 'Node 21',
    //   isExpandedChild: true,
    //   address: 'Gurgaon,Haryana',
    //   Name: 'node21',
    //   fillColor: '#e7704c',
    //   border: '#c15433',
    // },
    {
      title: 'Node 22',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node22',
      ReportingPerson: ['node114'],
      isRoot: false,
      fillColor: '#efd46e',
      border: '#d6b123',
    },
    {
      title: 'Node 23',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node23',
      ReportingPerson: ['node22'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 24',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node24',
      ReportingPerson: ['node22'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 25',
      isExpandedChild: false,
      address: 'Gurgaon,Haryana',
      Name: 'node25',
      // ReportingPerson: ['node22'],
      isRoot: false,
      fillColor: '#58b087',
      border: '#16955e',
    },
    {
      title: 'Node 26',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node26',
      ReportingPerson: [],
      isRoot: false,
      fillColor: '#14ad85',
    },
    {
      title: 'Node 27',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node27',
      ReportingPerson: ['node23', 'node24', 'node25'],
      isRoot: false,
      fillColor: '#659be5',
      border: '#3a6eb5',
    },
    {
      title: 'Node 28',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node28',
      ReportingPerson: [],
      isRoot: false,
      fillColor: '#14ad85',
    },
    {
      title: 'Node 29',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node29',
      ReportingPerson: ['node26', 'node27', 'node28', 'node116'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    {
      title: 'Node 210',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node210',
      ReportingPerson: ['node26', 'node27', 'node28'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
    {
      title: 'Node 211',
      isExpandedChild: true,
      address: 'Gurgaon,Haryana',
      Name: 'node211',
      ReportingPerson: ['node26', 'node27', 'node28'],
      isRoot: false,
      fillColor: '#8dbe6c',
      border: '#489911',
    },
  ];
  public nodeDefaults(obj: NodeModel): NodeModel {
    // obj.width = 40;
    // obj.height = 40;
    // //Initialize shape
    // obj.shape = { type: 'Basic', shape: 'Rectangle', cornerRadius: 7 };
    obj.width = 250;
    if (
      (obj as any).data.S_LOCATION_ID == '' ||
      (obj as any).data.S_CREATION_OPERATION_ID == ''
    ) {
      obj.height = 180;
    } else obj.height = 200;
    //Initialize shape
    obj.constraints =
      (NodeConstraints.Default &
        ~(
          NodeConstraints.Rotate |
          NodeConstraints.Select |
          NodeConstraints.Drag |
          NodeConstraints.Resize
        )) |
      NodeConstraints.Tooltip;

    let htmlNodeContent = `
    <div class="tooltip-container">
    <div class="tooltip-image">
      <img
        src="../../assets/images/.svg"
      />
    </div>
    <div class="tooltip-content">
      <div class="content-header">
        <div>Sample:  ${(obj as any).data.title}</div>
        <div>Location : ${(obj as any).data.Name}</div>
      </div>
      <div class="address">
      </div>
      <div class="cell-tag" id="cellLineTooltip_${obj.id}">
        <img
          class="cell-tag-image"
        src="../../assets/images/.svg"
        />
        <span class="cell-tag-text">Cell Line</span>
      </div>
      </div>
    </div>
  </div>
  `;

    obj.shape = {
      // content: htmlNodeContent,
      // type: 'HTML',
      // shape: 'Rectangle',
      // cornerRadius: 7,
    };
    // addInfo: {
    //   template: '<div style="width: 100px; height: 50px; text-align: center; line-height: 50px; color: white; font-size: 14px; border-radius: 5px;"></div>'
    // }

    let tooltipContent = `
    <div style="border: 1px solid #ccc; background-color: transparent; padding: 5px;">
              <div><strong>Name:</strong> ${(obj as any).data.title}</div>
              <div><strong>ID:</strong> ${(obj as any).data.Name}</div>
          </div>
    `;
    // obj.constraints = NodeConstraints.Default | NodeConstraints.Tooltip;
    (obj as any).tooltip.content = tooltipContent;
    (obj as any).tooltip.position = 'TopRight';
    (obj as any).tooltip.relativeMode = 'Object';

    obj.expandIcon = {
      shape: 'Minus',
    };
    obj.collapseIcon = {
      shape: 'Plus',
    };
    // console.log('obj :', obj);
    return obj;
  }
  public data: Object = {
    id: 'Name',
    parentId: 'ReportingPerson',
    dataSource: new DataManager(this.Data),
    //binds the external data with node
    doBinding: (nodeModel: NodeModel, data: DataInfo, diagram: Diagram) => {
      /* tslint:disable:no-string-literal */
      nodeModel.style = {
        fill: data['fillColor'],
        strokeWidth: 1,
        strokeColor: data['border'],
      };
    },
  };
  public created(): void {
    this.diagram.zoomTo({ type: 'ZoomOut' });
    this.diagram.fitToPage();
  }
  expandstateChange(event:any) {
    console.log('expnad', event);
    let currentCollapseNodeName = event.element.data.Name;
    console.log('current : Node : ', currentCollapseNodeName);

    //nodes collapsed
    if (!event.state) {
      let nodeHiddenByCollapse: any;
      for (var i = 0; i < this.diagram.nodes.length; i++) {
        // console.log('each : ', this.diagram.nodes[i]);
        let nodeElementData = (this.diagram.nodes[i] as any).properties.data;
        if (nodeElementData.ReportingPerson) {
          // console.log('found : ', nodeElementData);
          // console.log("ANS NDE :",nodeElementData.ReportingPerson.includes(currentCollapseNodeName), nodeElementData);
          if (
            nodeElementData.ReportingPerson.includes(currentCollapseNodeName)
          ) {
            // console.log('Final value : ', this.diagram.nodes[i]);
            if (this.diagram.nodes[i].visible) {
              this.diagram.nodes[i].visible = false;
              nodeHiddenByCollapse = this.diagram.nodes[i];

              // this.diagram.nodes[i].isExpanded = false;
            }
          }
        }
      }

      console.log('collasped hidden node : ', nodeHiddenByCollapse);

      if (nodeHiddenByCollapse) {
        let nodeHiddenByCollapseReportingPersons =
          nodeHiddenByCollapse.properties.data.ReportingPerson;
        nodeHiddenByCollapseReportingPersons.forEach((d:any) => {
          if (d != currentCollapseNodeName) {
            for (var i = 0; i < this.diagram.nodes.length; i++) {
              let nodeElementData = (this.diagram.nodes[i] as any).properties
                .data;
              let nodeParent = nodeElementData.ReportingPerson;
              if (nodeElementData.Name == d) {
                //check if node if linked with any upper parent
                console.log('Doe -- > ', this.diagram.nodes[i]);
                if (
                  nodeElementData.ReportingPerson &&
                  nodeElementData.ReportingPerson.length > 0
                )
                  // this.diagram.nodes[i].visible = false;
                  this.diagram.nodes[i].isExpanded = false;
                else {
                  this.diagram.nodes[i].visible = false;
                  this.diagram.nodes[i].isExpanded = false;
                }
              }
            }
          }
        });
      }
    } else {
      console.log('else');

      let nodeHiddenWhenExpanded: any;
      for (var i = 0; i < this.diagram.nodes.length; i++) {
        // console.log('each : ', this.diagram.nodes[i]);
        let nodeElementData = (this.diagram.nodes[i] as any).properties.data;
        if (nodeElementData.ReportingPerson) {
          if (
            nodeElementData.ReportingPerson.includes(currentCollapseNodeName)
          ) {
            if (nodeElementData.ReportingPerson.length > 1) {
              console.log('found parent new : ', this.diagram.nodes[i]);
              nodeHiddenWhenExpanded = this.diagram.nodes[i];
            }
            console.log('Final value : ', this.diagram.nodes[i]);
            if (this.diagram.nodes[i].visible) {
              this.diagram.nodes[i].visible = true;
              // nodeHiddenByCollapse = this.diagram.nodes[i];

              // this.diagram.nodes[i].isExpanded = false;
            }
          }
        }
      }
      if (nodeHiddenWhenExpanded) {
        let nodeHiddenWhenExpandedReportingPersons =
          nodeHiddenWhenExpanded.properties.data.ReportingPerson;
        nodeHiddenWhenExpandedReportingPersons.forEach((d:any) => {
          if (d != currentCollapseNodeName) {
            for (var i = 0; i < this.diagram.nodes.length; i++) {
              let nodeElementData = (this.diagram.nodes[i] as any).properties
                .data;
              let nodeParent = nodeElementData.ReportingPerson;
              if (nodeElementData.Name == d) {
                this.diagram.nodes[i].visible = true;
                this.diagram.nodes[i].isExpanded = true;
              }
            }
          }
        });
      }
    }
  }
  public connDefaults(connector: ConnectorModel): void {
    // connector.type = 'Orthogonal';
    // connector.cornerRadius = 7;
    // connector.targetDecorator.height = 7;
    // connector.targetDecorator.width = 7;
    // connector.style.strokeColor = '#6d6d6d';
    connector.type = 'Orthogonal';
    connector.constraints =
      ConnectorConstraints.Default |
      (ConnectorConstraints.Tooltip &
        ~(
          ConnectorConstraints.Select |
          ConnectorConstraints.Interaction |
          ConnectorConstraints.ReadOnly
        ));
    connector.cornerRadius = 7;
    (connector as any).targetDecorator.height = 7;
    (connector as any).targetDecorator.width = 7;
    (connector as any).targetDecorator.shape = `OpenArrow`;
    (connector as any).targetDecorator.style.fill = '#52247F';
    (connector as any).targetDecorator.style.strokeColor = '#52247F';
    (connector as any).style.strokeColor = '#C9BBD7';
  }

  public tool: DiagramTools = DiagramTools.ZoomPan;

  public snapSettings: SnapSettingsModel = {
    constraints: SnapConstraints.None,
  };

  public layout: LayoutModel = {
    type: 'ComplexHierarchicalTree',
    connectionPointOrigin: ConnectionPointOrigin.DifferentPoint,
    horizontalSpacing: 70,
    verticalSpacing: 70,
    orientation: 'TopToBottom',
    margin: { left: 10, right: 0, top: 50, bottom: 0 },
  };

}
